## dde-launchpad 2.0.15

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: CC0-1.0

cmake_minimum_required(VERSION 3.10)

project(dde-launchpad VERSION 0.7.0)

option(BUILD_TEST "Whether or not to build the tests" OFF)
option(CMAKE_EXPORT_COMPILE_COMMANDS "clangd support" ON)

set(CMAKE_CXX_STANDARD 17) # blurhash requires 17, otherwish we can still use 14
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON) # ensure adapter class can include launchercontroller.h
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

include(FeatureSummary)
include(GNUInstallDirs)

set(QT_NS Qt6)
set(DTK_NS Dtk6)
set(ASQT_NS AppStreamQt)

find_package(QT NAMES ${QT_NS} REQUIRED COMPONENTS Core)
find_package(${QT_NS} REQUIRED COMPONENTS Core Gui Concurrent Qml Svg Quick QuickControls2 LinguistTools)
find_package(${DTK_NS} REQUIRED COMPONENTS Core Gui)
find_package(${ASQT_NS} 1.0 REQUIRED)
find_package(ECM NO_MODULE)
if(Qt6_VERSION VERSION_GREATER_EQUAL 6.10)
  find_package(Qt6 COMPONENTS GuiPrivate REQUIRED)
endif()

set_package_properties(${ASQT_NS} PROPERTIES
    DESCRIPTION "Library that lists Appstream resources"
    URL "https://www.freedesktop.org"
    TYPE RECOMMENDED)

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

set(QML_IMPORT_PATH ${QML_IMPORT_PATH} ${CMAKE_CURRENT_BINARY_DIR}/ CACHE STRING "" FORCE)

if (ECM_FOUND)
    set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake;${CMAKE_MODULE_PATH};${ECM_MODULE_PATH};${PROJECT_SOURCE_DIR}/cmake")

    include(KDEClangFormat)
    include(KDEGitCommitHooks)
endif()

add_subdirectory(src/gioutils)
add_subdirectory(src/utils)
add_subdirectory(src/quick)
add_subdirectory(src/ddeintegration)
add_subdirectory(src/treelandintegration)
add_subdirectory(src/models)
add_subdirectory(qml/windowed)

if(BUILD_TEST)
    enable_testing()
    add_subdirectory(tests)
endif()

set(SOURCE_FILES
    desktopintegration.cpp desktopintegration.h
    launchercontroller.cpp launchercontroller.h
    debughelper.cpp debughelper.h
    inputeventitem.h inputeventitem.cpp
)

set(QML_FILES
    ${PROJECT_SOURCE_DIR}/qml/Helper.qml
    ${PROJECT_SOURCE_DIR}/qml/Main.qml
    ${PROJECT_SOURCE_DIR}/qml/FullscreenFrame.qml
    ${PROJECT_SOURCE_DIR}/qml/AppItemMenu.qml
    ${PROJECT_SOURCE_DIR}/qml/DummyAppItemMenu.qml
    ${PROJECT_SOURCE_DIR}/qml/GridViewContainer.qml
    ${PROJECT_SOURCE_DIR}/qml/DrawerFolder.qml
    ${PROJECT_SOURCE_DIR}/qml/IconItemDelegate.qml
    ${PROJECT_SOURCE_DIR}/qml/DebugDialog.qml
    ${PROJECT_SOURCE_DIR}/qml/DebugBounding.qml
    ${PROJECT_SOURCE_DIR}/qml/FolderGridViewPopup.qml
)
foreach(QML_FILE ${QML_FILES})
    get_filename_component(file_name ${QML_FILE} NAME)
    set_source_files_properties(${QML_FILE}
        PROPERTIES QT_RESOURCE_ALIAS ${file_name}
    )
endforeach()

get_target_property(WINDOWED_QML_FILES launcher-qml-windowed QT_QML_MODULE_QML_FILES)
# TODO: switch to the new qt_add_translations usage introduced in Qt 6.7
#       see also: https://www.qt.io/blog/revisited-i18n-with-cmake
set(QML_FILES_NEED_TRANSLATION
    ${PROJECT_SOURCE_DIR}/qml/AppItemMenu.qml
    ${PROJECT_SOURCE_DIR}/qml/DummyAppItemMenu.qml
    ${PROJECT_SOURCE_DIR}/qml/Main.qml
    ${PROJECT_SOURCE_DIR}/qml/FullscreenFrame.qml
    ${WINDOWED_QML_FILES}
)

set_source_files_properties(${PROJECT_SOURCE_DIR}/qml/Helper.qml
    PROPERTIES
        QT_QML_SINGLETON_TYPE TRUE
)

qt_add_dbus_adaptor(DBUS_ADAPTER_FILES dbus/org.deepin.dde.Launcher1.xml launchercontroller.h LauncherController)

qt_add_library(launchpadcommon SHARED
    ${SOURCE_FILES}
    ${DBUS_ADAPTER_FILES}
    ${RESOURCES}
    ${TRANSLATED_FILES}
)

qt_add_qml_module(launchpadcommon
    URI org.deepin.launchpad
    VERSION 1.0
    RESOURCES qml.qrc
    RESOURCE_PREFIX
        /qt/qml
    QML_FILES
        ${QML_FILES}
)
set_target_properties(launchpadcommon PROPERTIES PREFIX "")

target_link_libraries(launchpadcommon PUBLIC
    ${DTK_NS}::Core
    ${DTK_NS}::Gui
    Qt::GuiPrivate
    Qt::Qml
    Qt::Quick
    Qt::QuickControls2

    launcher-qml-windowed
    gio-utils
    launcher-utils
    launcher-qml-utils
    launcher-models
    dde-integration-dbus
    treeland-integration
)

install(TARGETS launchpadcommon DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(
    FILES dist/org.deepin.dde.shell.launchpad.appdata.xml
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/metainfo"
)

add_subdirectory(shell-launcher-applet)

=== dbus/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: CC0-1.0

configure_file(
    org.deepin.dde.Launcher1.service.in
    ${CMAKE_CURRENT_BINARY_DIR}/org.deepin.dde.Launcher1.service
    @ONLY)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/org.deepin.dde.Launcher1.service
        DESTINATION ${CMAKE_INSTALL_DATADIR}/dbus-1/services)

=== shell-launcher-applet/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: GPL-3.0-or-later

find_package(DDEShell REQUIRED)

add_library(shell-launcherapplet SHARED
    launcheritem.cpp
    launcheritem.h
)

target_link_libraries(shell-launcherapplet PRIVATE
    Dde::Shell
    launchpadcommon
)

ds_install_package(PACKAGE org.deepin.ds.dock.launcherapplet TARGET shell-launcherapplet)
ds_handle_package_translation(
PACKAGE org.deepin.ds.dock.launcherapplet
QML_FILES
    ${QML_FILES_NEED_TRANSLATION}
    ${CMAKE_CURRENT_LIST_DIR}/package/launcheritem.qml
)

=== systemd/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: CC0-1.0

if (NOT DEFINED SYSTEMD_USER_UNIT_DIR)
    find_package(PkgConfig REQUIRED)
    pkg_check_modules(Systemd REQUIRED systemd)
    pkg_get_variable(SYSTEMD_USER_UNIT_DIR systemd systemduserunitdir)
endif()

configure_file(
    org.deepin.dde.Launcher1.service.in
    ${CMAKE_CURRENT_BINARY_DIR}/org.deepin.dde.Launcher1.service
    @ONLY)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/org.deepin.dde.Launcher1.service
        DESTINATION ${SYSTEMD_USER_UNIT_DIR})

=== tests/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: CC0-1.0

find_package(Qt6 REQUIRED COMPONENTS Core Test)

qt_standard_project_setup()

macro(launchpad_add_tests)
    foreach(_testname ${ARGN})
        qt_add_executable(launchpad-${_testname} ${_testname}.cpp)
        target_link_libraries(launchpad-${_testname} PRIVATE Qt6::Core Qt6::Test launchpadcommon)
        add_test(NAME launchpad-${_testname} COMMAND launchpad-${_testname})
    endforeach()
endmacro()

launchpad_add_tests(
    itemspagetest
    gioappinfotest
    searchfilterproxymodeltest
)

=== src/quick/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: CC0-1.0

find_package(${QT_NS} REQUIRED Quick)

add_library(launcher-qml-utils OBJECT)

target_sources(launcher-qml-utils
PRIVATE
    launcherappiconprovider.cpp
    launcherfoldericonprovider.cpp
    blurhashimageprovider.cpp
)

target_sources(launcher-qml-utils PUBLIC
FILE_SET HEADERS
FILES
    launcherappiconprovider.h
    launcherfoldericonprovider.h
    blurhashimageprovider.h
)

target_include_directories(launcher-qml-utils PUBLIC ${CMAKE_CURRENT_LIST_DIR})
target_link_libraries(launcher-qml-utils PRIVATE Qt::Quick launcher-utils)

=== src/treelandintegration/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: CC0-1.0

find_package(Qt6 REQUIRED GLOBAL COMPONENTS WaylandClient)
if(Qt6_VERSION VERSION_GREATER_EQUAL 6.10)
  find_package(Qt6 COMPONENTS WaylandClientPrivate REQUIRED)
endif()

set(CMAKE_INCLUDE_CURRENT_DIR ON)

add_library(treeland-integration OBJECT
    personalizationmanager.cpp
    personalizationwindow.cpp
)

qt_generate_wayland_protocol_client_sources(treeland-integration
    FILES
        ${CMAKE_CURRENT_SOURCE_DIR}/treeland-personalization-manager-v1.xml
)

target_sources(treeland-integration PUBLIC
FILE_SET HEADERS
FILES
    personalizationmanager.h
    personalizationwindow.h
)

target_link_libraries(treeland-integration
PRIVATE
    Qt6::WaylandClient
    Qt6::WaylandClientPrivate
)

=== debian/changelog ===
dde-launchpad (2.0.15) unstable; urgency=medium

  * i18n: Updates for project Deepin Desktop Environment (#652)

 -- wujiangyu <wujiangyu@uniontech.com>  Thu, 23 Oct 2025 16:00:36 +0800

dde-launchpad (2.0.14) unstable; urgency=medium

  * fix: compatibility with Qt 6.10
  * feat: improve app list focus behavior and styling
  * feat: add tap handler to hide launcher

 -- zhangkun <zhangkun2@uniontech.com>  Thu, 16 Oct 2025 21:17:01 +0800

dde-launchpad (2.0.13) unstable; urgency=medium

  * refactor: replace DragHandler with MouseArea for app dragging
  * fix: ensure remove tone for pinyin first letter search
  * fix: remove category check from resetViewState
  * feat: add icon scaling with keyboard shortcuts

 -- YeShanShan <yeshanshan@uniontech.com>  Fri, 10 Oct 2025 17:32:35 +0800

dde-launchpad (2.0.12) unstable; urgency=medium

  * fix: add right margin to windowed frame layout

 -- YeShanShan <yeshanshan@uniontech.com>  Thu, 18 Sep 2025 20:44:37 +0800

dde-launchpad (2.0.11) unstable; urgency=medium

  * fix: improve focus management in folder grid view

 -- wujiangyu <wujiangyu@uniontech.com>  Thu, 04 Sep 2025 17:34:40 +0800

dde-launchpad (2.0.10) unstable; urgency=medium

  * feat: add logs with dlogcover.
  * [skip CI] Translate org.deepin.ds.dock.launcherapplet.ts in zh_HK
  * [skip CI] Translate org.deepin.ds.dock.launcherapplet.ts in zh_CN
  * [skip CI] Translate org.deepin.ds.dock.launcherapplet.ts in zh_TW
  * fix: adjust WindowedFrame layout width
  * fix: reset page index on frame change

 -- wujiangyu <wujiangyu@uniontech.com>  Thu, 28 Aug 2025 17:52:37 +0800

=== debian/control ===
Source: dde-launchpad
Section: DDE
Priority: optional
Maintainer: Gary Wang <wangzichong@deepin.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 pkg-config,
 libglib2.0-dev,
# v-- to get systemduserunitdir from its pkg-config data
 systemd,
 qt6-base-dev,
 qt6-base-private-dev,
 qt6-svg-dev,
 qt6-declarative-dev,
 qt6-tools-dev,
 qt6-tools-dev-tools,
 qt6-wayland-dev,
 qt6-wayland-private-dev,
 libdtkcommon-dev,
 libdtk6core-dev (>= 6.0.43),
# v-- provides qdbusxml2cpp-fix binary
 libdtk6core-bin,
# v-- provides DHiDPIHelper
 libdtk6gui-dev (>= 6.0.19),
 libdtk6declarative-dev (>= 6.0.19),
 libdde-shell-dev (>= 0.0.10),
 libappstreamqt-dev (>= 1.0.0)
Standards-Version: 4.6.0
Rules-Requires-Root: no

Package: dde-launchpad
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 dde-application-manager (>> 1.2.2),
 dde-application-wizard-daemon-compat,
 libdtk6gui(>= 6.0.19),
 libdtk6declarative(>= 6.0.19),
 qml6-module-qtquick-layouts,
 qml6-module-qtquick-window,
 qml6-module-qtquick-controls,
 qml6-module-qtquick-controls2-styles-chameleon,
 qml6-module-qt-labs-platform,
# v-- actually should be depended by qqc2-styles-chameleon
 qml6-module-qt5compat-graphicaleffects
Conflicts: dde-launcher
Replaces: dde-launcher
Description: The "launcher" or "start menu" component for DDE
 Display all installed applications and allow user to launch applications, which is convenient for users to operate quickly

=== debian/rules ===
#!/usr/bin/make -f

export QT_SELECT=5

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -Wall
export DEB_CXXFLAGS_MAINT_APPEND = -Wall
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed -Wl,-z,relro -Wl,-z,now -Wl,-z,noexecstack -Wl,-E

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
		dh $@ --parallel

override_dh_auto_configure:
		dh_auto_configure -- \
			-DVERSION=$(DEB_VERSION_UPSTREAM) \
			-DPREFER_QT_5=OFF

## dde-launchpad 2.0.17

=== CMakeLists.txt ===
--- 
+++ 
@@ -145,5 +145,10 @@
     FILES dist/org.deepin.dde.shell.launchpad.appdata.xml
     DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/metainfo"
 )
+# debug config file
+install(FILES ${CMAKE_SOURCE_DIR}/dist/deepin-debug-config/org.deepin.dde.launchpad.json
+    DESTINATION ${CMAKE_INSTALL_DATADIR}/deepin-debug-config/deepin-debug-config.d)
+install(FILES ${CMAKE_SOURCE_DIR}/dist/deepin-log-config/org.deepin.dde.launchpad.json
+    DESTINATION ${CMAKE_INSTALL_DATADIR}/deepin-log-viewer/deepin-log.conf.d)
 
 add_subdirectory(shell-launcher-applet)

=== debian/changelog ===
dde-launchpad (2.0.17) unstable; urgency=medium

  * chore: adapt debugging settings function

 -- xionglinlin <xionglinlin@uniontech.com>  Thu, 13 Nov 2025 19:48:43 +0800

dde-launchpad (2.0.16) unstable; urgency=medium

  * fix: reset grid view index when hiding launcher
  * fix: avoid keyboard focus on menu that not visible

 -- Robertkill <lvpeilong@uniontech.com>  Thu, 30 Oct 2025 20:02:06 +0800
